pcl::search::FlannSearch< PointT, FlannDistance > Class Template Reference
Module search

search::FlannSearch is a generic FLANN wrapper class for the new search interface. More...

`#include <pcl/search/flann_search.h>`

Inheritance diagram for pcl::search::FlannSearch< PointT, FlannDistance >:

## Classes

class | FlannIndexCreator
| Helper class that creates a FLANN index from a given FLANN matrix. More...
class | KdTreeIndexCreator
| Creates a FLANN KdTreeSingleIndex from the given input data. More...
class | KdTreeMultiIndexCreator
| Creates a FLANN KdTreeIndex of multiple randomized trees from the given input data, suitable for feature matching. More...
class | KMeansIndexCreator
| Creates a FLANN KdTreeSingleIndex from the given input data. More...

## Public Types

typedef boost::shared_ptr< FlannSearch< PointT, FlannDistance > > | Ptr
typedef boost::shared_ptr< const FlannSearch< PointT, FlannDistance > > | ConstPtr
typedef Search< PointT >::PointCloud | PointCloud
typedef Search< PointT >::PointCloudConstPtr | PointCloudConstPtr
typedef boost::shared_ptr< std::vector< int > > | IndicesPtr
typedef boost::shared_ptr< const std::vector< int > > | IndicesConstPtr
typedef boost::shared_ptr< flann::Matrix< float > > | MatrixPtr
typedef boost::shared_ptr< const flann::Matrix< float > > | MatrixConstPtr
typedef flann::NNIndex< FlannDistance > | Index
typedef boost::shared_ptr< flann::NNIndex< FlannDistance > > | IndexPtr
typedef pcl::PointRepresentation< PointT > | PointRepresentation
typedef boost::shared_ptr< PointRepresentation > | PointRepresentationPtr
typedef boost::shared_ptr< const PointRepresentation > | PointRepresentationConstPtr
typedef boost::shared_ptr< FlannIndexCreator > | FlannIndexCreatorPtr
Public Types inherited from pcl::search::Search< PointT >
typedef pcl::PointCloud< PointT > | PointCloud
typedef PointCloud::Ptr | PointCloudPtr
typedef PointCloud::ConstPtr | PointCloudConstPtr
typedef boost::shared_ptr< pcl::search::Search< PointT > > | Ptr
typedef boost::shared_ptr< const pcl::search::Search< PointT > > | ConstPtr
typedef boost::shared_ptr< std::vector< int > > | IndicesPtr
typedef boost::shared_ptr< const std::vector< int > > | IndicesConstPtr

## Public Member Functions

| FlannSearch (bool sorted=true, FlannIndexCreatorPtr creator=FlannIndexCreatorPtr(new KdTreeIndexCreator()))
virtual | ~FlannSearch ()
| Destructor for FlannSearch. More...
void | setEpsilon (double eps)
| Set the search epsilon precision (error bound) for nearest neighbors searches. More...
double | getEpsilon ()
| Get the search epsilon precision (error bound) for nearest neighbors searches. More...
void | setChecks (int checks)
| Set the number of checks to perform during approximate searches in multiple randomized trees. More...
int | getChecks ()
| Get the number of checks to perform during approximate searches in multiple randomized trees. More...
virtual void | setInputCloud (const PointCloudConstPtr &cloud, const IndicesConstPtr &indices=IndicesConstPtr())
| Provide a pointer to the input dataset. More...
int | nearestKSearch (const PointT &point, int k, std::vector< int > &k_indices, std::vector< float > &k_sqr_distances) const
| Search for the k-nearest neighbors for the given query point. More...
virtual void | nearestKSearch (const PointCloud &cloud, const std::vector< int > &indices, int k, std::vector< std::vector< int > > &k_indices, std::vector< std::vector< float > > &k_sqr_distances) const
| Search for the k-nearest neighbors for the given query point. More...
int | radiusSearch (const PointT &point, double radius, std::vector< int > &k_indices, std::vector< float > &k_sqr_distances, unsigned int max_nn=0) const
| Search for all the nearest neighbors of the query point in a given radius. More...
virtual void | radiusSearch (const PointCloud &cloud, const std::vector< int > &indices, double radius, std::vector< std::vector< int > > &k_indices, std::vector< std::vector< float > > &k_sqr_distances, unsigned int max_nn=0) const
| Search for the k-nearest neighbors for the given query point. More...
void | setPointRepresentation (const PointRepresentationConstPtr &point_representation)
| Provide a pointer to the point representation to use to convert points into k-D vectors. More...
PointRepresentationConstPtr const | getPointRepresentation ()
| Get a pointer to the point representation used when converting points into k-D vectors. More...
Public Member Functions inherited from pcl::search::Search< PointT >
| Search (const std::string &name="", bool sorted=false)
| Constructor. More...
virtual | ~Search ()
| Destructor. More...
virtual const std::string & | getName () const
| Returns the search method name. More...
virtual void | setSortedResults (bool sorted)
| sets whether the results should be sorted (ascending in the distance) or not More...
virtual bool | getSortedResults ()
| Gets whether the results should be sorted (ascending in the distance) or not Otherwise the results may be returned in any order. More...
virtual PointCloudConstPtr | getInputCloud () const
| Get a pointer to the input point cloud dataset. More...
virtual IndicesConstPtr | getIndices () const
| Get a pointer to the vector of indices used. More...
template<typename PointTDiff >
int | nearestKSearchT (const PointTDiff &point, int k, std::vector< int > &k_indices, std::vector< float > &k_sqr_distances) const
| Search for k-nearest neighbors for the given query point. More...
virtual int | nearestKSearch (const PointCloud &cloud, int index, int k, std::vector< int > &k_indices, std::vector< float > &k_sqr_distances) const
| Search for k-nearest neighbors for the given query point. More...
virtual int | nearestKSearch (int index, int k, std::vector< int > &k_indices, std::vector< float > &k_sqr_distances) const
| Search for k-nearest neighbors for the given query point (zero-copy). More...
virtual void | nearestKSearch (const PointCloud &cloud, const std::vector< int > &indices, int k, std::vector< std::vector< int > > &k_indices, std::vector< std::vector< float > > &k_sqr_distances) const
| Search for the k-nearest neighbors for the given query point. More...
template<typename PointTDiff >
void | nearestKSearchT (const pcl::PointCloud< PointTDiff > &cloud, const std::vector< int > &indices, int k, std::vector< std::vector< int > > &k_indices, std::vector< std::vector< float > > &k_sqr_distances) const
| Search for the k-nearest neighbors for the given query point. More...
template<typename PointTDiff >
int | radiusSearchT (const PointTDiff &point, double radius, std::vector< int > &k_indices, std::vector< float > &k_sqr_distances, unsigned int max_nn=0) const
| Search for all the nearest neighbors of the query point in a given radius. More...
virtual int | radiusSearch (const PointCloud &cloud, int index, double radius, std::vector< int > &k_indices, std::vector< float > &k_sqr_distances, unsigned int max_nn=0) const
| Search for all the nearest neighbors of the query point in a given radius. More...
virtual int | radiusSearch (int index, double radius, std::vector< int > &k_indices, std::vector< float > &k_sqr_distances, unsigned int max_nn=0) const
| Search for all the nearest neighbors of the query point in a given radius (zero-copy). More...
virtual void | radiusSearch (const PointCloud &cloud, const std::vector< int > &indices, double radius, std::vector< std::vector< int > > &k_indices, std::vector< std::vector< float > > &k_sqr_distances, unsigned int max_nn=0) const
| Search for all the nearest neighbors of the query point in a given radius. More...
template<typename PointTDiff >
void | radiusSearchT (const pcl::PointCloud< PointTDiff > &cloud, const std::vector< int > &indices, double radius, std::vector< std::vector< int > > &k_indices, std::vector< std::vector< float > > &k_sqr_distances, unsigned int max_nn=0) const
| Search for all the nearest neighbors of the query points in a given radius. More...

## Protected Member Functions

void | convertInputToFlannMatrix ()
| converts the input data to a format usable by FLANN More...
Protected Member Functions inherited from pcl::search::Search< PointT >
void | sortResults (std::vector< int > &indices, std::vector< float > &distances) const

## Protected Attributes

IndexPtr | index_
| The FLANN index. More...
FlannIndexCreatorPtr | creator_
| The index creator, used to (re-) create the index when the search data is passed. More...
MatrixPtr | input_flann_
| Input data in FLANN format. More...
float | eps_
| Epsilon for approximate NN search. More...
int | checks_
| Number of checks to perform for approximate NN search using the multiple randomized tree index. More...
bool | input_copied_for_flann_
PointRepresentationConstPtr | point_representation_
int | dim_
std::vector< int > | index_mapping_
bool | identity_mapping_
Protected Attributes inherited from pcl::search::Search< PointT >
PointCloudConstPtr | input_
IndicesConstPtr | indices_
bool | sorted_results_
std::string | name_

## Detailed Description

### template<typename PointT, typename FlannDistance = flann::L2_Simple <float>>
class pcl::search::FlannSearch< PointT, FlannDistance >

search::FlannSearch is a generic FLANN wrapper class for the new search interface.

It is able to wrap any FLANN index type, e.g. the kd tree as well as indices for high-dimensional searches and intended as a more powerful and cleaner successor to KdTreeFlann.

By default, this class creates a single kd tree for indexing the input data. However, for high dimensions (> 10), it is often better to use the multiple randomized kd tree index provided by FLANN in combination with the flann::L2 distance functor. During search in this type of index, the number of checks to perform before terminating the search can be controlled. Here is a code example if a high-dimensional 2-NN search:

// Feature and distance type
typedef SHOT352 FeatureT;
typedef flann::L2<float> DistanceT;
// Search and index types
typedef search::FlannSearch<FeatureT, DistanceT> SearchT;
typedef typename SearchT::FlannIndexCreatorPtr CreatorPtrT;
typedef typename SearchT::KdTreeMultiIndexCreator IndexT;
typedef typename SearchT::PointRepresentationPtr RepresentationPtrT;
// Features
PointCloud<FeatureT>::Ptr query, target;
// Fill query and target with calculated features...
// Instantiate search object with 4 randomized trees and 256 checks
SearchT search (true, CreatorPtrT (new IndexT (4)));
search.setPointRepresentation (RepresentationPtrT (new DefaultFeatureRepresentation<FeatureT>));
search.setChecks (256);
search.setInputCloud (target);
// Do search
std::vector<std::vector<int> > k_indices;
std::vector<std::vector<float> > k_sqr_distances;
search.nearestKSearch (*query, std::vector<int> (), 2, k_indices, k_sqr_distances);

Author
  Andreas Muetzel
  Anders Glent Buch (multiple randomized kd tree interface)

Definition at line 101 of file flann_search.h.

## Member Typedef Documentation

template<typename PointT, typename FlannDistance = flann::L2_Simple <float>>

typedef boost::shared_ptr<const FlannSearch<PointT, FlannDistance> > pcl::search::FlannSearch< PointT, FlannDistance >::ConstPtr

Definition at line 109 of file flann_search.h.

template<typename PointT, typename FlannDistance = flann::L2_Simple <float>>

typedef boost::shared_ptr<FlannIndexCreator> pcl::search::FlannSearch< PointT, FlannDistance >::FlannIndexCreatorPtr

Definition at line 145 of file flann_search.h.

template<typename PointT, typename FlannDistance = flann::L2_Simple <float>>

typedef flann::NNIndex< FlannDistance > pcl::search::FlannSearch< PointT, FlannDistance >::Index

Definition at line 120 of file flann_search.h.

template<typename PointT, typename FlannDistance = flann::L2_Simple <float>>

typedef boost::shared_ptr<flann::NNIndex <FlannDistance > > pcl::search::FlannSearch< PointT, FlannDistance >::IndexPtr

Definition at line 121 of file flann_search.h.

template<typename PointT, typename FlannDistance = flann::L2_Simple <float>>

typedef boost::shared_ptr<const std::vector<int> > pcl::search::FlannSearch< PointT, FlannDistance >::IndicesConstPtr

Definition at line 115 of file flann_search.h.

template<typename PointT, typename FlannDistance = flann::L2_Simple <float>>

typedef boost::shared_ptr<std::vector<int> > pcl::search::FlannSearch< PointT, FlannDistance >::IndicesPtr

Definition at line 114 of file flann_search.h.

template<typename PointT, typename FlannDistance = flann::L2_Simple <float>>

typedef boost::shared_ptr<const flann::Matrix <float> > pcl::search::FlannSearch< PointT, FlannDistance >::MatrixConstPtr

Definition at line 118 of file flann_search.h.

template<typename PointT, typename FlannDistance = flann::L2_Simple <float>>

typedef boost::shared_ptr<flann::Matrix <float> > pcl::search::FlannSearch< PointT, FlannDistance >::MatrixPtr

Definition at line 117 of file flann_search.h.

template<typename PointT, typename FlannDistance = flann::L2_Simple <float>>

typedef Search<PointT>::PointCloud pcl::search::FlannSearch< PointT, FlannDistance >::PointCloud

Definition at line 111 of file flann_search.h.

template<typename PointT, typename FlannDistance = flann::L2_Simple <float>>

typedef Search<PointT>::PointCloudConstPtr pcl::search::FlannSearch< PointT, FlannDistance >::PointCloudConstPtr

Definition at line 112 of file flann_search.h.

template<typename PointT, typename FlannDistance = flann::L2_Simple <float>>

typedef pcl::PointRepresentation<PointT> pcl::search::FlannSearch< PointT, FlannDistance >::PointRepresentation

Definition at line 123 of file flann_search.h.

template<typename PointT, typename FlannDistance = flann::L2_Simple <float>>

typedef boost::shared_ptr<const PointRepresentation> pcl::search::FlannSearch< PointT, FlannDistance >::PointRepresentationConstPtr

Definition at line 125 of file flann_search.h.

template<typename PointT, typename FlannDistance = flann::L2_Simple <float>>

typedef boost::shared_ptr<PointRepresentation> pcl::search::FlannSearch< PointT, FlannDistance >::PointRepresentationPtr

Definition at line 124 of file flann_search.h.

template<typename PointT, typename FlannDistance = flann::L2_Simple <float>>

typedef boost::shared_ptr<FlannSearch<PointT, FlannDistance> > pcl::search::FlannSearch< PointT, FlannDistance >::Ptr

Definition at line 108 of file flann_search.h.

## Constructor & Destructor Documentation

template<typename PointT , typename FlannDistance >

pcl::search::FlannSearch< PointT, FlannDistance >::FlannSearch | ( | bool | sorted = `true`,
|  | FlannIndexCreatorPtr | creator = `FlannIndexCreatorPtr (new KdTreeIndexCreator ())`
| ) |  |

Definition at line 72 of file flann_search.hpp.

References pcl::search::FlannSearch< PointT, FlannDistance >::dim_, and pcl::search::FlannSearch< PointT, FlannDistance >::point_representation_.

template<typename PointT , typename FlannDistance >

pcl::search::FlannSearch< PointT, FlannDistance >::~FlannSearch | ( |  | ) |

virtual

Destructor for FlannSearch.

Definition at line 81 of file flann_search.hpp.

References pcl::search::FlannSearch< PointT, FlannDistance >::input_copied_for_flann_, and pcl::search::FlannSearch< PointT, FlannDistance >::input_flann_.

## Member Function Documentation

template<typename PointT , typename FlannDistance >

void pcl::search::FlannSearch< PointT, FlannDistance >::convertInputToFlannMatrix | ( |  | ) |

protected

converts the input data to a format usable by FLANN

Definition at line 362 of file flann_search.hpp.

References pcl::search::FlannSearch< PointT, FlannDistance >::dim_, pcl::search::FlannSearch< PointT, FlannDistance >::identity_mapping_, pcl::search::FlannSearch< PointT, FlannDistance >::index_mapping_, pcl::search::Search< PointT >::indices_, pcl::search::Search< PointT >::input_, pcl::search::FlannSearch< PointT, FlannDistance >::input_copied_for_flann_, pcl::search::FlannSearch< PointT, FlannDistance >::input_flann_, and pcl::search::FlannSearch< PointT, FlannDistance >::point_representation_.

Referenced by pcl::search::FlannSearch< PointT, FlannDistance >::setInputCloud().

template<typename PointT, typename FlannDistance = flann::L2_Simple <float>>

int pcl::search::FlannSearch< PointT, FlannDistance >::getChecks | ( |  | ) |

inline

Get the number of checks to perform during approximate searches in multiple randomized trees.

Definition at line 252 of file flann_search.h.

template<typename PointT, typename FlannDistance = flann::L2_Simple <float>>

double pcl::search::FlannSearch< PointT, FlannDistance >::getEpsilon | ( |  | ) |

inline

Get the search epsilon precision (error bound) for nearest neighbors searches.

Definition at line 236 of file flann_search.h.

template<typename PointT, typename FlannDistance = flann::L2_Simple <float>>

PointRepresentationConstPtr const pcl::search::FlannSearch< PointT, FlannDistance >::getPointRepresentation | ( |  | ) |

inline

Get a pointer to the point representation used when converting points into k-D vectors.

Definition at line 328 of file flann_search.h.

template<typename PointT, typename FlannDistance >

int pcl::search::FlannSearch< PointT, FlannDistance >::nearestKSearch | ( | const PointT & | point,
|  | int | k,
|  | std::vector< int > & | k_indices,
|  | std::vector< float > & | k_sqr_distances
| ) |  | const

virtual

Search for the k-nearest neighbors for the given query point.

Parameters

  [in] | point | the given query point
  [in] | k | the number of neighbors to search for
  [out] | k_indices | the resultant indices of the neighboring points (must be resized to k a priori!)
  [out] | k_sqr_distances | the resultant squared distances to the neighboring points (must be resized to k a priori!)

Returns
  number of neighbors found

Implements pcl::search::Search< PointT >.

Definition at line 100 of file flann_search.hpp.

References pcl::search::FlannSearch< PointT, FlannDistance >::checks_, pcl::search::FlannSearch< PointT, FlannDistance >::eps_, pcl::search::FlannSearch< PointT, FlannDistance >::identity_mapping_, pcl::search::FlannSearch< PointT, FlannDistance >::index_, pcl::search::FlannSearch< PointT, FlannDistance >::index_mapping_, pcl::search::FlannSearch< PointT, FlannDistance >::point_representation_, and pcl::search::Search< PointT >::sorted_results_.

template<typename PointT, typename FlannDistance >

void pcl::search::FlannSearch< PointT, FlannDistance >::nearestKSearch | ( | const PointCloud & | cloud,
|  | const std::vector< int > & | indices,
|  | int | k,
|  | std::vector< std::vector< int > > & | k_indices,
|  | std::vector< std::vector< float > > & | k_sqr_distances
| ) |  | const

virtual

Search for the k-nearest neighbors for the given query point.

Parameters

  [in] | cloud | the point cloud data
  [in] | indices | a vector of point cloud indices to query for nearest neighbors
  [in] | k | the number of neighbors to search for
  [out] | k_indices | the resultant indices of the neighboring points, k_indices[i] corresponds to the neighbors of the query point i
  [out] | k_sqr_distances | the resultant squared distances to the neighboring points, k_sqr_distances[i] corresponds to the neighbors of the query point i

Definition at line 142 of file flann_search.hpp.

References pcl::search::FlannSearch< PointT, FlannDistance >::checks_, pcl::search::FlannSearch< PointT, FlannDistance >::dim_, pcl::search::FlannSearch< PointT, FlannDistance >::eps_, pcl::search::FlannSearch< PointT, FlannDistance >::identity_mapping_, pcl::search::FlannSearch< PointT, FlannDistance >::index_, pcl::search::FlannSearch< PointT, FlannDistance >::index_mapping_, pcl::PointCloud< PointT >::is_dense, pcl::search::FlannSearch< PointT, FlannDistance >::point_representation_, pcl::PointCloud< PointT >::size(), and pcl::search::Search< PointT >::sorted_results_.

template<typename PointT, typename FlannDistance >

int pcl::search::FlannSearch< PointT, FlannDistance >::radiusSearch | ( | const PointT & | point,
|  | double | radius,
|  | std::vector< int > & | k_indices,
|  | std::vector< float > & | k_sqr_distances,
|  | unsigned int | max_nn = `0`
| ) |  | const

virtual

Search for all the nearest neighbors of the query point in a given radius.

Parameters

  [in] | point | the given query point
  [in] | radius | the radius of the sphere bounding all of p_q's neighbors
  [out] | k_indices | the resultant indices of the neighboring points
  [out] | k_sqr_distances | the resultant squared distances to the neighboring points
  [in] | max_nn | if given, bounds the maximum returned neighbors to this value. If max_nn is set to 0 or to a number higher than the number of points in the input cloud, all neighbors in radius will be returned.

Returns
  number of neighbors found in radius

Implements pcl::search::Search< PointT >.

Definition at line 230 of file flann_search.hpp.

References pcl::search::FlannSearch< PointT, FlannDistance >::checks_, pcl::search::FlannSearch< PointT, FlannDistance >::eps_, pcl::search::FlannSearch< PointT, FlannDistance >::identity_mapping_, pcl::search::FlannSearch< PointT, FlannDistance >::index_, pcl::search::FlannSearch< PointT, FlannDistance >::index_mapping_, pcl::search::FlannSearch< PointT, FlannDistance >::point_representation_, and pcl::search::Search< PointT >::sorted_results_.

template<typename PointT, typename FlannDistance >

void pcl::search::FlannSearch< PointT, FlannDistance >::radiusSearch | ( | const PointCloud & | cloud,
|  | const std::vector< int > & | indices,
|  | double | radius,
|  | std::vector< std::vector< int > > & | k_indices,
|  | std::vector< std::vector< float > > & | k_sqr_distances,
|  | unsigned int | max_nn = `0`
| ) |  | const

virtual

Search for the k-nearest neighbors for the given query point.

Parameters

  [in] | cloud | the point cloud data
  [in] | indices | a vector of point cloud indices to query for nearest neighbors
  [in] | radius | the radius of the sphere bounding all of p_q's neighbors
  [out] | k_indices | the resultant indices of the neighboring points, k_indices[i] corresponds to the neighbors of the query point i
  [out] | k_sqr_distances | the resultant squared distances to the neighboring points, k_sqr_distances[i] corresponds to the neighbors of the query point i
  [in] | max_nn | if given, bounds the maximum returned neighbors to this value

Definition at line 273 of file flann_search.hpp.

References pcl::search::FlannSearch< PointT, FlannDistance >::checks_, pcl::search::FlannSearch< PointT, FlannDistance >::dim_, pcl::search::FlannSearch< PointT, FlannDistance >::eps_, pcl::search::FlannSearch< PointT, FlannDistance >::identity_mapping_, pcl::search::FlannSearch< PointT, FlannDistance >::index_, pcl::search::FlannSearch< PointT, FlannDistance >::index_mapping_, pcl::PointCloud< PointT >::is_dense, pcl::search::FlannSearch< PointT, FlannDistance >::point_representation_, pcl::PointCloud< PointT >::size(), and pcl::search::Search< PointT >::sorted_results_.

template<typename PointT, typename FlannDistance = flann::L2_Simple <float>>

void pcl::search::FlannSearch< PointT, FlannDistance >::setChecks | ( | int | checks | ) |

inline

Set the number of checks to perform during approximate searches in multiple randomized trees.

Parameters

  [in] | checks | number of checks to perform during approximate searches in multiple randomized trees.

Definition at line 245 of file flann_search.h.

template<typename PointT, typename FlannDistance = flann::L2_Simple <float>>

void pcl::search::FlannSearch< PointT, FlannDistance >::setEpsilon | ( | double | eps | ) |

inline

Set the search epsilon precision (error bound) for nearest neighbors searches.

Parameters

  [in] | eps | precision (error bound) for nearest neighbors searches

Definition at line 229 of file flann_search.h.

template<typename PointT , typename FlannDistance >

void pcl::search::FlannSearch< PointT, FlannDistance >::setInputCloud | ( | const PointCloudConstPtr & | cloud,
|  | const IndicesConstPtr & | indices = `IndicesConstPtr ()`
| ) |  |

virtual

Provide a pointer to the input dataset.

Parameters

  [in] | cloud | the const boost shared pointer to a PointCloud message
  [in] | indices | the point indices subset that is to be used from cloud

Reimplemented from pcl::search::Search< PointT >.

Definition at line 89 of file flann_search.hpp.

References pcl::search::FlannSearch< PointT, FlannDistance >::convertInputToFlannMatrix(), pcl::search::FlannSearch< PointT, FlannDistance >::creator_, pcl::search::FlannSearch< PointT, FlannDistance >::index_, pcl::search::Search< PointT >::indices_, pcl::search::Search< PointT >::input_, and pcl::search::FlannSearch< PointT, FlannDistance >::input_flann_.

template<typename PointT, typename FlannDistance = flann::L2_Simple <float>>

void pcl::search::FlannSearch< PointT, FlannDistance >::setPointRepresentation | ( | const PointRepresentationConstPtr & | point_representation | ) |

inline

Provide a pointer to the point representation to use to convert points into k-D vectors.

Parameters

  [in] | point_representation | the const boost shared pointer to a PointRepresentation

Definition at line 318 of file flann_search.h.

## Member Data Documentation

template<typename PointT, typename FlannDistance = flann::L2_Simple <float>>

int pcl::search::FlannSearch< PointT, FlannDistance >::checks_

protected

Number of checks to perform for approximate NN search using the multiple randomized tree index.

Definition at line 357 of file flann_search.h.

Referenced by pcl::search::FlannSearch< PointT, FlannDistance >::nearestKSearch(), and pcl::search::FlannSearch< PointT, FlannDistance >::radiusSearch().

template<typename PointT, typename FlannDistance = flann::L2_Simple <float>>

FlannIndexCreatorPtr pcl::search::FlannSearch< PointT, FlannDistance >::creator_

protected

The index creator, used to (re-) create the index when the search data is passed.

Definition at line 345 of file flann_search.h.

Referenced by pcl::search::FlannSearch< PointT, FlannDistance >::setInputCloud().

template<typename PointT, typename FlannDistance = flann::L2_Simple <float>>

int pcl::search::FlannSearch< PointT, FlannDistance >::dim_

protected

Definition at line 363 of file flann_search.h.

Referenced by pcl::search::FlannSearch< PointT, FlannDistance >::convertInputToFlannMatrix(), pcl::search::FlannSearch< PointT, FlannDistance >::FlannSearch(), pcl::search::FlannSearch< PointT, FlannDistance >::nearestKSearch(), and pcl::search::FlannSearch< PointT, FlannDistance >::radiusSearch().

template<typename PointT, typename FlannDistance = flann::L2_Simple <float>>

float pcl::search::FlannSearch< PointT, FlannDistance >::eps_

protected

Epsilon for approximate NN search.

Definition at line 353 of file flann_search.h.

Referenced by pcl::search::FlannSearch< PointT, FlannDistance >::nearestKSearch(), and pcl::search::FlannSearch< PointT, FlannDistance >::radiusSearch().

template<typename PointT, typename FlannDistance = flann::L2_Simple <float>>

bool pcl::search::FlannSearch< PointT, FlannDistance >::identity_mapping_

protected

Definition at line 366 of file flann_search.h.

Referenced by pcl::search::FlannSearch< PointT, FlannDistance >::convertInputToFlannMatrix(), pcl::search::FlannSearch< PointT, FlannDistance >::nearestKSearch(), and pcl::search::FlannSearch< PointT, FlannDistance >::radiusSearch().

template<typename PointT, typename FlannDistance = flann::L2_Simple <float>>

IndexPtr pcl::search::FlannSearch< PointT, FlannDistance >::index_

protected

The FLANN index.

Definition at line 341 of file flann_search.h.

Referenced by pcl::search::FlannSearch< PointT, FlannDistance >::nearestKSearch(), pcl::search::FlannSearch< PointT, FlannDistance >::radiusSearch(), and pcl::search::FlannSearch< PointT, FlannDistance >::setInputCloud().

template<typename PointT, typename FlannDistance = flann::L2_Simple <float>>

std::vector<int> pcl::search::FlannSearch< PointT, FlannDistance >::index_mapping_

protected

Definition at line 365 of file flann_search.h.

Referenced by pcl::search::FlannSearch< PointT, FlannDistance >::convertInputToFlannMatrix(), pcl::search::FlannSearch< PointT, FlannDistance >::nearestKSearch(), and pcl::search::FlannSearch< PointT, FlannDistance >::radiusSearch().

template<typename PointT, typename FlannDistance = flann::L2_Simple <float>>

bool pcl::search::FlannSearch< PointT, FlannDistance >::input_copied_for_flann_

protected

Definition at line 359 of file flann_search.h.

Referenced by pcl::search::FlannSearch< PointT, FlannDistance >::convertInputToFlannMatrix(), and pcl::search::FlannSearch< PointT, FlannDistance >::~FlannSearch().

template<typename PointT, typename FlannDistance = flann::L2_Simple <float>>

MatrixPtr pcl::search::FlannSearch< PointT, FlannDistance >::input_flann_

protected

Input data in FLANN format.

Definition at line 349 of file flann_search.h.

Referenced by pcl::search::FlannSearch< PointT, FlannDistance >::convertInputToFlannMatrix(), pcl::search::FlannSearch< PointT, FlannDistance >::setInputCloud(), and pcl::search::FlannSearch< PointT, FlannDistance >::~FlannSearch().

template<typename PointT, typename FlannDistance = flann::L2_Simple <float>>

PointRepresentationConstPtr pcl::search::FlannSearch< PointT, FlannDistance >::point_representation_

protected

Definition at line 361 of file flann_search.h.

Referenced by pcl::search::FlannSearch< PointT, FlannDistance >::convertInputToFlannMatrix(), pcl::search::FlannSearch< PointT, FlannDistance >::FlannSearch(), pcl::search::FlannSearch< PointT, FlannDistance >::nearestKSearch(), and pcl::search::FlannSearch< PointT, FlannDistance >::radiusSearch().

The documentation for this class was generated from the following files:

- /build/pcl-6_P28C/pcl-1.7.2/search/include/pcl/search/flann_search.h
- /build/pcl-6_P28C/pcl-1.7.2/search/include/pcl/search/impl/flann_search.hpp